AchievementDungeons = class(Turbine.UI.Control)
function AchievementDungeons:Constructor(handler)
    Turbine.UI.Control.Constructor(self)

    self.fornost = {
        ["Wrath of Earth"] = true,
        ["Wrath of Fire"] = true,
        ["Wrath of Water"] = true,
        ["Wrath of Shadow"] = true,
    }

    self.garthAgarwen = {
        ["Arboretum"] = true,
        ["Barrows"] = true,
        ["Fortress"] = true,
    }

    self.annuminas  = {
        ["Glinghant"] = true,
        ["Haudh Valandil"] = true,
        ["Ost Elendil"] = true,
    }

    self.barrows = {
       ["Sambrog"] = true,
       ["Thadúr"] = true,
       ["Great-barrow"] = true,
    }

    
    self.dungeonClustsers = {
        ["Fornost"] = self.fornost,
        ["Barrows"] = self.barrows,
        ["Annuminas"] = self.annuminas,
        ["Garth Agarwen"] =  self.garthAgarwen,
    }

    self.dungeonAchievements = {
        ["Fornost"] = "Blood Thirsty Archaeologist",
        ["Barrows"] = "Grave Disturber",
        ["Annuminas"] = "City cleanser",
        ["Garth Agarwen"] =  "Paint it Red",
    }

    self.handler = handler
end

function AchievementDungeons:HandleCompletion(dungeonName, data)
    for key, value in pairs(self.dungeonClustsers) do
        if value[dungeonName] then
            local completionCount = 0
            for completedDungeon, _ in pairs(value) do
                if data.Dungeons[completedDungeon] then
                    completionCount = completionCount + 1
                end

                if completionCount == PrimeUtils.Utils.Tablelength(value) then
                    self.handler:AchievementAchieved(self.handler:NameToID(self.dungeonAchievements[key]))
                    return
                end
            end
        end
    end
end

